/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Cyrill Burgener
 *
 */

/**
    @file OrxoKartKart.h
    @brief Declaration of the OrxoKartKart class.
*/

#ifndef _OrxoKartKart_H__
#define _OrxoKartKart_H__

#include "OrxoKartPrereqs.h"

#include "worldentities/pawns/SpaceShip.h"

namespace orxonox
{
    class _OrxoKartExport OrxoKartKart : public SpaceShip
    {
        public:
            OrxoKartKart(Context* context);

            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;

            virtual void moveFrontBack(const Vector2& value) override;

            virtual void moveRightLeft(const Vector2& value) override;

            virtual void moveUpDown(const Vector2& value) override;

            virtual void rotateYaw(const Vector2& value) override;

            virtual void rotatePitch(const Vector2& value) override;

            virtual void rotateRoll(const Vector2& value) override;
    };
}

#endif /* _OrxoKartKart_H__ */
