/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Marc Dreher
 *
 */

#ifndef _PacmanHUDinfo_H__
#define _PacmanHUDinfo_H__

#include "PacmanPrereqs.h"
#include "Pacman.h"

#include "tools/interfaces/Tickable.h"
#include "overlays/OverlayText.h"
#include <cstring>

namespace orxonox
{
    class _PacmanExport PacmanHUDinfo : public OverlayText, public Tickable
    {
        public:
            PacmanHUDinfo(Context* context);

            virtual void tick(float dt) override;
            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
            virtual void changedOwner() override;

            inline void setShowPoints(bool value)
                { this->bShowPoints_ = value; }
            inline bool getShowPoints() const
                { return this->bShowPoints_; }

            inline void setShowMessage(bool value){
                bShowMessage_ = value;
            }
            inline bool getShowMessage() const
                { return this->bShowMessage_; }

            inline void setMessageID(int value){
                messageID = value;
            }
            inline int getMessageID() const
                { return messageID; }

            inline void setGhoststatus(bool value){
                this->bShowGhoststatus_ = value;
            }
            inline int getGhoststatus() const
                { return this->bShowGhoststatus_; }

            inline void setGameover(bool value){
                this->showgameover = value;
            }
            inline int getGameover() const
                { return this->showgameover; }

            inline void setlive(bool value){
                this->showlive = value;
            }
            inline int getlive() const
                { return this->showlive; }

            inline void setlevel(bool value){
                this->showlevel = value;
            }
            inline int getlevel() const
                { return this->showlevel; }


        private:
            Pacman* PacmanGame;
            bool bShowPoints_;
            bool bShowMessage_;
            bool bShowGhoststatus_;
            bool showgameover;
            bool showlive;
            bool showlevel;
            int messageID;
    };
}
#endif /* _PacmanHUDinfo_H__ */