/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Authors:
 *  
 *   Co-authors:
 *      ...
 *
 */



#ifndef Wagnis_h
#define Wagnis_h

#include "WagnisPrereqs.h"
#include "WagnisGameboard.h"
#include "WagnisProvince.h"
#include "WagnisPlayer.h"
#include "gametypes/Deathmatch.h"


/** Die Wagnis Klasse hat die folgenden Aufgaben:
 *  1. Das Spiel erstellen.
 *  - Gameboard initialisieren
 *  - Provinzen initialisieren
 *  - Provinzen verbinden (Nachbarschaften eintragen)
 *  - Spieler initialisieren
 *  -
 * 
 *  2. Den Spielablauf steuern
 *  - Für einen Spieler berechnen wie viele Truppen er setzen darf.
 *  - Den Funktion "setTroops(int troops)" beim Spieler aufrufen.
 *  - Die Funktion "playerTurn()" bei jedem Spieler aufrufen.
 *  - 
 * 
 **/


namespace orxonox
{
    class /**_WagnisExport**/ Wagnis : public Deathmatch
    {
        public:
        Wagnis(Context* context);
        virtual ~Wagnis();
        void start();
        void tick(float);
        void playerFinishedStageCallback(WagnisPlayer*);



        WagnisGameboard* gameBoard;

        int active_player;
        int initial_reinforcements_left;
        GameStage gameStage;
        std::vector<WagnisPlayer*> players;
        void createGame();
        bool findGameBoard();
        int provinceCount();
        int reinforcementsCounter(int);
        int getContinentValue(int);
        int unoccupiedProvinces();
    };
}
#endif
 /* Wagnis_h */